// Code generated by counterfeiter. DO NOT EDIT.
package smtpserverfakes

import (
	"net"
	"sync"

	"gitlab.com/hackandsla.sh/letterbox/internal/smtpserver/spf"
)

type FakeSpfChecker struct {
	GetStatusStub        func(net.IP, string, string) (spf.Status, error)
	getStatusMutex       sync.RWMutex
	getStatusArgsForCall []struct {
		arg1 net.IP
		arg2 string
		arg3 string
	}
	getStatusReturns struct {
		result1 spf.Status
		result2 error
	}
	getStatusReturnsOnCall map[int]struct {
		result1 spf.Status
		result2 error
	}
	ValidateAlignmentStub        func(string, string) (bool, error)
	validateAlignmentMutex       sync.RWMutex
	validateAlignmentArgsForCall []struct {
		arg1 string
		arg2 string
	}
	validateAlignmentReturns struct {
		result1 bool
		result2 error
	}
	validateAlignmentReturnsOnCall map[int]struct {
		result1 bool
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeSpfChecker) GetStatus(arg1 net.IP, arg2 string, arg3 string) (spf.Status, error) {
	fake.getStatusMutex.Lock()
	ret, specificReturn := fake.getStatusReturnsOnCall[len(fake.getStatusArgsForCall)]
	fake.getStatusArgsForCall = append(fake.getStatusArgsForCall, struct {
		arg1 net.IP
		arg2 string
		arg3 string
	}{arg1, arg2, arg3})
	stub := fake.GetStatusStub
	fakeReturns := fake.getStatusReturns
	fake.recordInvocation("GetStatus", []interface{}{arg1, arg2, arg3})
	fake.getStatusMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2, arg3)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeSpfChecker) GetStatusCallCount() int {
	fake.getStatusMutex.RLock()
	defer fake.getStatusMutex.RUnlock()
	return len(fake.getStatusArgsForCall)
}

func (fake *FakeSpfChecker) GetStatusCalls(stub func(net.IP, string, string) (spf.Status, error)) {
	fake.getStatusMutex.Lock()
	defer fake.getStatusMutex.Unlock()
	fake.GetStatusStub = stub
}

func (fake *FakeSpfChecker) GetStatusArgsForCall(i int) (net.IP, string, string) {
	fake.getStatusMutex.RLock()
	defer fake.getStatusMutex.RUnlock()
	argsForCall := fake.getStatusArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2, argsForCall.arg3
}

func (fake *FakeSpfChecker) GetStatusReturns(result1 spf.Status, result2 error) {
	fake.getStatusMutex.Lock()
	defer fake.getStatusMutex.Unlock()
	fake.GetStatusStub = nil
	fake.getStatusReturns = struct {
		result1 spf.Status
		result2 error
	}{result1, result2}
}

func (fake *FakeSpfChecker) GetStatusReturnsOnCall(i int, result1 spf.Status, result2 error) {
	fake.getStatusMutex.Lock()
	defer fake.getStatusMutex.Unlock()
	fake.GetStatusStub = nil
	if fake.getStatusReturnsOnCall == nil {
		fake.getStatusReturnsOnCall = make(map[int]struct {
			result1 spf.Status
			result2 error
		})
	}
	fake.getStatusReturnsOnCall[i] = struct {
		result1 spf.Status
		result2 error
	}{result1, result2}
}

func (fake *FakeSpfChecker) ValidateAlignment(arg1 string, arg2 string) (bool, error) {
	fake.validateAlignmentMutex.Lock()
	ret, specificReturn := fake.validateAlignmentReturnsOnCall[len(fake.validateAlignmentArgsForCall)]
	fake.validateAlignmentArgsForCall = append(fake.validateAlignmentArgsForCall, struct {
		arg1 string
		arg2 string
	}{arg1, arg2})
	stub := fake.ValidateAlignmentStub
	fakeReturns := fake.validateAlignmentReturns
	fake.recordInvocation("ValidateAlignment", []interface{}{arg1, arg2})
	fake.validateAlignmentMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeSpfChecker) ValidateAlignmentCallCount() int {
	fake.validateAlignmentMutex.RLock()
	defer fake.validateAlignmentMutex.RUnlock()
	return len(fake.validateAlignmentArgsForCall)
}

func (fake *FakeSpfChecker) ValidateAlignmentCalls(stub func(string, string) (bool, error)) {
	fake.validateAlignmentMutex.Lock()
	defer fake.validateAlignmentMutex.Unlock()
	fake.ValidateAlignmentStub = stub
}

func (fake *FakeSpfChecker) ValidateAlignmentArgsForCall(i int) (string, string) {
	fake.validateAlignmentMutex.RLock()
	defer fake.validateAlignmentMutex.RUnlock()
	argsForCall := fake.validateAlignmentArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeSpfChecker) ValidateAlignmentReturns(result1 bool, result2 error) {
	fake.validateAlignmentMutex.Lock()
	defer fake.validateAlignmentMutex.Unlock()
	fake.ValidateAlignmentStub = nil
	fake.validateAlignmentReturns = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakeSpfChecker) ValidateAlignmentReturnsOnCall(i int, result1 bool, result2 error) {
	fake.validateAlignmentMutex.Lock()
	defer fake.validateAlignmentMutex.Unlock()
	fake.ValidateAlignmentStub = nil
	if fake.validateAlignmentReturnsOnCall == nil {
		fake.validateAlignmentReturnsOnCall = make(map[int]struct {
			result1 bool
			result2 error
		})
	}
	fake.validateAlignmentReturnsOnCall[i] = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakeSpfChecker) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.getStatusMutex.RLock()
	defer fake.getStatusMutex.RUnlock()
	fake.validateAlignmentMutex.RLock()
	defer fake.validateAlignmentMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeSpfChecker) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}
